#!/usr/bin/perl 
format STDOUT =
    @<<<<<<<<<<<<<<<<<<  @###.#######     @###.#######    @###.###
$label{$j},$data[$j],$data2[$j],$diff
.

$home = `echo \$HOME`;chomp($home);
$label{0}= "(0)  E-EN(g)";
$label{1}= "(1)  E-EN(liq)" ;
$label{2}= "(2)  G-P(liq) ";
$label{3}= "(4)  G-CDS(liq) ";
$label{4}= "(7)  DeltaE-EN(liq)";
$label{5}= "(9)  DeltaG-S(liq) ";
$label{6}= "Loewdin dipole moment ";
$label{7}= "RLPA dipole moment ";
$label{8}= "CM2 dipole moment ";
$label{9}="CM3 dipole moment ";
$label{10}="RMS gradient ";
$labelstart = 2;
$nlabels = 10;

sub collect1 {
open (FILE, "<$file");
@amsol="";
 while (<FILE>) {
  if (/\(0\)  E-EN\(g\) gas-phase\s+\w+\s+elect-nuc energy\s+([-]?\d*\.\d+)\s*/){
    $amsol[0]=$1;
  }
  if (/\(0\)  E-EN\(g\) gas-phase\s+\w+[+]?\w+?[-]?\w+?\s+elect-nuc energy\s+([-]?\d*\.\d+)\s*/){
    $amsol[0]=$1;
  }
  if (/\(1\)  E-EN\(liq\) elect-nuc\s+\w+\s+energy of solute\s+([-]?\d*\.\d+)\s*/){
    $amsol[1]=$1;
 }
 if (/\(1\)  E-EN\(liq\) elect-nuc\s+\w+[+]?\w+?[-]?\w+?\s+energy of solute\s+([-]?\d*\.\d+)\s*/){
    $amsol[1]=$1;
  }
  if (/\(2\)  G-P\(liq\) polarization free energy of solvation\s+([-]?\d*\.\d+)\s*/){
    $amsol[2]=$1;
  }
  if (/\(4\)  G-CDS\(liq\) cavity-dispersion-solvent structure\s+([-]?\d*\.\d+)\s*/){
    $amsol[3]=$1;
  }
  if (/^     free energy\s+([-]?\d*\.\d+)\s*/){
    $amsol[3]=$1;
  }
  if (/     energy of solute molecule \(7\) = \(1\) - \(0\)\s+([-]?\d*\.\d+)\s*/){
    $amsol[4] = $1;
  } 
  if (/     \(9\) = \(6\) - \(0\)\s+([-]?\d*\.\d+)\s*/) {
    $amsol[5] = $1;
  }
  if (/^                       RMS GRADIENT =\s+(\d*\.\d+)/) {
#    ($c,$c,$c,$c,$amsol[10]) = split(/\s+/);
     $amsol[10] = $1;
  }
 }
 close(FILE);
 return (@amsol);
}

sub collect2 {
 open(FILE, "<$file");
 @amsol = "";
 while(<FILE>) {
   if (/ Lowdin\s+([-]?\d*\.\d+)\s*([-]?\d*\.\d+)\s*([-]?\d*\.\d+)\s*([-]?\d*\.\d+)\s*/) {
      $amsol[6]=$4;
   }
   if (/ RLPA\s+([-]?\d*\.\d+)\s*([-]?\d*\.\d+)\s*([-]?\d*\.\d+)\s*([-]?\d*\.\d+)\s*/) {
      $amsol[7]=$4;
   }
   if (/ CM2\s+([-]?\d*\.\d+)\s*([-]?\d*\.\d+)\s*([-]?\d*\.\d+)\s*([-]?\d*\.\d+)\s*/) {
      $amsol[8]=$4;
   }
#   if (/ CM3\s+([-]?\d*\.\d+)\s*([-]?\d*\.\d+)\s*([-]?\d*\.\d+)\s*([-]?\d*\.\d+)\s*/) {
#      $amsol[9]=$4;

    if (/ CM3(\s+\S+){3}\s+(\S+)/) {
      $amsol[9]=$2;
   }
 }
 close(FILE);
 return (@amsol);
}

foreach $i (0 .. $#ARGV) {
 ($file) = split/\.log/,$ARGV[$i];
 $gmsplus = "$file.log";
 @data = "";
 @data2 = "";
if ($file =~ m/test\d+\.HF\.?0/ or $file =~ m/test\d+\.0/ or $file =~ m/test\d+\.25./
     or $file =~ m/test\d+\.428./ or $file =~ m/test\d+\.517./ or $file =~ m/test\d+\.606./ 
     or $file =~ m/test\d+\.999./) {
   #print "$file\n";
   $file = $gmsplus; 
   @data = collect2 ($file);
   $file = "../Output/$file";
   @data2 = collect2 ($file);
 } else {
   $file = $gmsplus;
   @data = collect1 ($file);
   $file = "../Output/$file";
   @data2 = collect1 ($file);
 }
   print "$ARGV[$i]\n";
 for $j ($labelstart .. $nlabels){
  if ($data2[$j] != 0.0){
    $diff=$data[$j] - $data2[$j];
    write;
  }
 }
}

